function framesetsize(w,h) {}
function framesetsize2(w,h) {
    var obj = new Object;
    obj.width = w;
    obj.height = h;
    FB.Canvas.setSize(obj);
}

function resetInputHints(root) {
    if(typeof root == 'undefined' || root.length == 0) {
        root = $('html, body');
    }
    root.find('input[type!="hidden"], textarea').each(function() {
        if($(this).attr('data-hint')) {
            $(this).val($(this).attr('data-hint'));
        }
    });
    root.find('input[type!="hidden"], textarea').one('focusin', function() {       
        if($(this).attr('data-hint')) {
            $(this).val(''); 
        }
    });
}

function fix_canvas() {
    // Try without.
}

function profileUnsub(type, id) {
	$.ajax({ 
		url: 'subscription.php?signed_request=' + window.signed_request + '&action=remove&type='+ type +'&id=' + id,
		complete: function(result) {
			if(result) {
				$('.'+type+id).slideUp(400, function() { 
					$(this).remove();
				});             
			} else {
				// Handle error;
			}
		}
	});
}

function changeThreadSub(id) {
    if($(".subscribe.button a:contains('Unsubscribe')").length > 0) {
        $.ajax({ 
            url: 'subscription.php?signed_request=' + window.signed_request + '&action=remove&type=thread&id=' + id,
            complete: function(result) {
                if(result) {
                    $('.subscribe.button a').text('Subscribe');              
                } else {
                    // Handle error;
                }
            }
        });
    } else {
        $.ajax({ 
            url: 'subscription.php?signed_request=' + window.signed_request + '&action=add&type=thread&id=' + id,
            complete: function(result) {
                if(result) {
                    $('.subscribe.button a').text('Unsubscribe');              
                } else {
                    // Handle error;
                }
            }
        });
    }   
}

function changeForumSub(id) {
    if($(".subscribe.button a:contains('Unsubscribe')").length > 0) {
        $.ajax({ 
            url: 'subscription.php?signed_request=' + window.signed_request + '&action=remove&type=forum&id=' + id,
            complete: function(result) {
                if(result) {
                    $('.subscribe.button a').text('Subscribe');              
                } else {
                    // Handle error;
                }
            }
        });
    } else {
        $.ajax({ 
            url: 'subscription.php?signed_request=' + window.signed_request + '&action=add&type=forum&id=' + id,
            complete: function(result) {
                if(result) {
                    $('.subscribe.button a').text('Unsubscribe');              
                } else {
                    // Handle error;
                }
            }
        });
    }   
}

function searchValidation() {
    var keyword = $.trim($('#search-txt').val());

    if(keyword != '' && keyword != $('#search-txt').data('hint')) {
        keyword = encodeURIComponent(keyword);
        $('#loading').show();
        $.ajax({
            url: 'search.php?keywords='+keyword+'&signed_request='+window.signed_request,
            success: function(response) {
                $('#loading').hide();
                var res = JSON.parse(response);
                if(res.response.errormessage == 'search') {
                   top.location.href = window.app_root + 'category_stream.php?category=Search_All_'+res.show.searchid;                 
                } else if(res.response.errorlist[0][0] == 'words_very_common') {
					showSearchTooltip("Please use less common search terms!");
                } else if(res.response.errorlist[0][0] == 'searchnoresults' && res.response.errorlist[0][1] != "") {
                    showSearchTooltip(res.response.errorlist[0][1]);
                } else if(res.response.errorlist[0][0] == 'searchnoresults' && res.response.errorlist[0][1] == "") {
                    showSearchTooltip("Search returned no results");
                } else {
                    showSearchTooltip("An unknown error occurred! (" + res.response.errorlist + ")");
                }
            }
        });
        return false;
    } else {
       showSearchTooltip("Please enter a search query.");
    }
}
function showSearchTooltip(error) {
    $('#search').qtip({ 
        content: error,
        position: {
            my: "top middle",
            at: "bottom middle",
            viewport: $(window)
        },
        show: {
            target: $('#header')
        },
        style: {
            classes: 'ui-tooltip-red ui-tooltip-shadow ui-tooltip-rounded'
        },
        hide: false
    });
    var api = $('#search').data('qtip');
    api.show();
    $('#search input').one('keydown', function() {
        $('#search').qtip('destroy');
    });
}
function isEnter(e) { 
    key = (document.all) ? e.keyCode : e.which; 
    if(key == 13) {
        return true;
    }
    return false;
}

function showAllCategories(){
    var firstHeight = $('body').height();
    $('div .hide_category').slideToggle('slow');
}

function moveToHash(postid) {
    var anchor = $("a[name*=" + postid + "]");
    FB.Canvas.scrollTo(0, anchor.offset().top);
    return false;
}

function sendVotePoll(pollid, multiple){

    var data = {};
    data['signed_request'] = window.signed_request;
    data['do'] = 'vote';
    data['pollid'] = pollid;
    data['multiple'] = multiple;
    data['optionnumber'] = '';
    $('.poll input:checked').each(function(){
        var value = $(this).val();
	if(value != '' && value != undefined){
            if(data['optionnumber'] == '')
                data['optionnumber'] = value;
            else{
                data['optionnumber'] += ',' + value;
            }
	}
    });

    $.ajax({
        dataType: 'json',
        type: 'POST',
        url: 'pollvote.php',
        cache: false,
        data: data,
        success: function(data, textStatus, jqXHR){
            $('.poll .message').slideUp(200);
			var messageSelect = '.poll .error';
            if(!data.error) {
                var messageSelect = '.poll .normal';
			}
            $(messageSelect).html(data.message[2]).slideDown(200).delay(2000).slideUp(200, function() {
                if(data.message[0]) {
                    $('.pollbits').slideUp(200, function() {
                        $('.poll .buttons').slideUp(150);
                    });
                    showHidePollResults(pollid, true);
                }
            });                      
        },
        error: function (xhr, textStatus, errorThrown) {
            $('.poll .error').html('Unspecified error, please try again later.');
        }
    });
}

function showHidePollResults(pollid, show){
    var dShow = $('.pollResults:visible').length;
    if(typeof show != 'undefined' && show || dShow <= 0) {
        var data = {};
        data['signed_request'] = window.signed_request;
        data['do'] = 'showresults';
        data['pollid'] = pollid;
        $.ajax({
            dataType: 'json',
            type: 'POST',
            url: 'pollvote.php',
            cache: false,
            data: data, 
            success: function(data, textStatus, jqXHR){                        
                if(data.error) {
                    var messageSelect = '.poll .error';
                    $(messageSelect).html(data.message);
                } else {
                    var messageSelect = '.poll .pollResults';
                    $(messageSelect).html(data.message);
                    $('.pollResults').slideDown(200);
                }                                                       
            },
            error: function (xhr, textStatus, errorThrown) {
                $('.poll .error').html('Unspecified error, please try again later.');
            }
        });  
    } else {
        $('.pollResults').slideUp(200);
    }
}

function fix_forum_paths() {
    $('img[src^="images"]').each(function() {
        var src = window.site_root + $(this).attr("src");
        $(this).attr('src', src);
    });
    $('a[href^="showthread.php"]').each(function() {
        var href = window.site_root + $(this).attr("href");
        $(this).attr('href', href);
    });
}
function fix_links() {
    var whitelist = [
        'category_list.php',
        'category_stream.php',
        'category_item.php',
        'forums.php',
        'profile.php',
        'register_form.php',
        'logout.php',
        '#'
    ];
        
    $('a').each(function()
    {
        var $this = $(this);
        var href = $this.attr("href");
        if(!href) {
            return;
        }
        for(var i = 0; i < whitelist.length; i++) {                  
            if(href.lastIndexOf(whitelist[i], 0) === 0) {              
                var newurl = window.app_root + href;                      
                $this.attr("href", newurl);
                $this.attr("target", "_top");
                return;
            }
        }
        if(!$this.attr("target")) {
            $this.attr("target", "_blank");
        }
    });
}
function fix_ad_photos() {
    // Get any photos on the Ad box 'line'
    var $photos = $("div.small li.CategorySummaryItem_ApiGetNewTop_Photos");
    // Check if we are overflowing
    var length = $photos.length;
    if(length >= 3) {
        // Hide any photos > 2
        for(var i = 2; i < length; i++) {
            $photos.eq(i).hide();
        }
    }
}
fix_links();
fix_forum_paths();
$(function() {
    fix_ad_photos();
    resetInputHints();
    setInterval(function() {
        framesetsize2($("#mainwrap").width(), $("#mainwrap").height() + 30);
    }, 500);
});
